Models/Department.cs
//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated from a template.
//
//     Manual changes to this file may cause unexpected behavior in your application.
//     Manual changes to this file will be overwritten if the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace TooJaVile.Models
{
    using System;
    using System.Collections.Generic;
    
    public partial class Department
    {
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2214:DoNotCallOverridableMethodsInConstructors")]
        public Department()
        {
            this.People = new HashSet<Person>();
        }
    
        public int Id { get; set; }
        public string Name { get; set; }
        public int SortId { get; set; }
        public Nullable<int> PictureId { get; set; }
    
        public virtual DataFile DataFile { get; set; }
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
        public virtual ICollection<Person> People { get; set; }
    }
}

Controllers/DepartmentsController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using TooJaVile.Models;
using System.IO;

namespace TooJaVile.Controllers
{
    //public partial class Department
    //{
    //    //public static Dictionary<int, string> Departments = new Dictionary<int, string>
    //    //{
    //    //    {0, "Müük" },
    //    //    {1, "Ost" },
    //    //    {2, "Ladu" },
    //    //    {3, "Raamatupidamine" },
    //    //};
    //    //public string DepartmentName =>
    //    //    Departments.ContainsKey(Id) ? Departments[DepartmentNimi] : "";
    //}

    public class DepartmentsController : MyController
    {
        private TooJaVileEntities db = new TooJaVileEntities();

        // GET: Departments
        public ActionResult Index()
        {
            CheckPerson();
            ViewBag.CurrentPerson = CurrentPerson;
            var departments = db.Departments.Include(d => d.DataFile);
            return View(departments.ToList());
        }

        // GET: Departments/Details/5
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Department department = db.Departments.Find(id);
            if (department == null)
            {
                return HttpNotFound();
            }
            return View(department);
        }


        // GET: Departments/Create
        public ActionResult Create()
        {
            ViewBag.PictureId = new SelectList(db.DataFiles, "Id", "ContentType");
            return View();
        }

        // POST: Departments/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include = "Id,Name,SortId,PictureId")] Department department, HttpPostedFileBase file)
        {
            if (ModelState.IsValid)
            {
                db.Departments.Add(department);
                db.SaveChanges();

                //siia pildiga toimetamine
                if (file != null && file.ContentLength > 0)
                    using (BinaryReader br = new BinaryReader(file.InputStream)) //see loeb pildifaili sisse
                    {
                        DataFile df = new DataFile
                        {
                            FileName = file.FileName.Split('\\').Last(),
                            ContentType = file.ContentType,
                            Content = br.ReadBytes(file.ContentLength),
                            Created = DateTime.Now,
                        };
                        db.DataFiles.Add(df);
                        db.SaveChanges();
                        //selleks et vana pilt kustutada, jätame meelde pildi numbri
                        int? vanaPiltId = department.PictureId;
                        department.PictureId = df.Id;
                        db.SaveChanges();
                        if (vanaPiltId.HasValue)
                        {
                            db.DataFiles.Remove(db.DataFiles.Find(vanaPiltId.Value));
                            db.SaveChanges();
                        }
                    }

                //siin lõpeb toimetamine pildiga

                return RedirectToAction("Index");
            }

            ViewBag.PictureId = new SelectList(db.DataFiles, "Id", "ContentType", department.PictureId);
            return View(department);
        }

        // GET: Departments/Edit/5
        public ActionResult Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Department department = db.Departments.Find(id);
            if (department == null)
            {
                return HttpNotFound();
            }
            ViewBag.PictureId = new SelectList(db.DataFiles, "Id", "ContentType", department.PictureId);
            
            return View(department);
        }

        // POST: Departments/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit([Bind(Include = "Id,Name,SortId,PictureId")] Department department, HttpPostedFileBase file) //liia lisasin sulgudesse asju juurde
        {
            if (ModelState.IsValid)
            {
                db.Entry(department).State = EntityState.Modified;
                db.Entry(department).Property("PictureId").IsModified = false; //lisasin selle juurde, muidu kustub pilt ära
                db.SaveChanges();
                //siia pildiga toimetamine
                if(file != null && file.ContentLength > 0 )
                    using (BinaryReader br = new BinaryReader(file.InputStream)) //see loeb pildifaili sisse
                    {
                        DataFile df = new DataFile
                        {
                            FileName = file.FileName.Split('\\').Last(), 
                            ContentType = file.ContentType,
                            Content = br.ReadBytes(file.ContentLength),
                            Created = DateTime.Now,
                        };
                        db.DataFiles.Add(df);
                        db.SaveChanges();
                        //selleks et vana pilt kustutada, jätame meelde pildi numbri
                        int? vanaPiltId = department.PictureId;
                        department.PictureId = df.Id;
                        db.SaveChanges();
                        if (vanaPiltId.HasValue)
                        {                            
                            db.DataFiles.Remove(db.DataFiles.Find(vanaPiltId.Value));
                            db.SaveChanges();
                        }
                    }

                        //siin lõpeb toimetamine pildiga
                        return RedirectToAction("Index");
            }
            ViewBag.PictureId = new SelectList(db.DataFiles, "Id", "ContentType", department.PictureId);
            return View(department);
        }

        // GET: Departments/Delete/5
        public ActionResult Delete(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Department department = db.Departments.Find(id);
            if (department == null)
            {
                return HttpNotFound();
            }
            return View(department);
        }

        // POST: Departments/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            Department department = db.Departments.Find(id);
            db.Departments.Remove(department);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}

Controllers/MyController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.IO;
using TooJaVile.Models;

namespace TooJaVile.Controllers
{
    public class MyController : Controller
    {
        TooJaVileEntities db = new TooJaVileEntities();
        [OutputCache(Duration = 3600, VaryByParam = "id", Location = System.Web.UI.OutputCacheLocation.Any)]
        public ActionResult Content(int? id)
        {
            DataFile df = db.DataFiles.Find(id);
            if (df == null) return HttpNotFound();
            return File(df.Content, df.ContentType);
        }

        //meie veel ei oska checkperson teha
        protected Person CurrentPerson = null; // siis on hea kohe see PersonObject omale taskusse panna
        protected void CheckPerson()
        {
            if (Request.IsAuthenticated)        // kontrollida vaja vaid siis
                if ((CurrentPerson?.Email ?? "") != User.Identity.Name)    // kui juba ei ole meeles või on vale
                {
                    CurrentPerson = db.People.Where(x => x.Email == User.Identity.Name).SingleOrDefault();
                    if (CurrentPerson == null)


                    {
                        using (ApplicationDbContext dba = new ApplicationDbContext())
                        {
                            ApplicationUser u = dba.Users.Where(x => x.Email == User.Identity.Name).SingleOrDefault();
                            db.People.Add(CurrentPerson = new Person
                            {
                                Email = User.Identity.Name,
                                FirstName = u.FirstName,
                                LastName = u.LastName,
                                BirthDate = u.BirthDate
                            });
                            db.SaveChanges();
                        }
                    }
                }
                else CurrentPerson = null;
        }

        protected void ChangeDataFile(HttpPostedFileBase file, Action<int> change, int? oldId)
        {
            if (file != null && file.ContentLength > 0)
                using (BinaryReader br = new BinaryReader(file.InputStream))
                {
                    DataFile df = new DataFile
                    {
                        Content = br.ReadBytes(file.ContentLength),
                        FileName = file.FileName.Split('\\').Last().Split('/').Last(),
                        ContentType = file.ContentType,
                        Created = DateTime.Now
                    };
                    db.DataFiles.Add(df);
                    db.SaveChanges();
                    change(df.Id);
                    if (oldId.HasValue)
                    {
                        db.DataFiles.Remove(db.DataFiles.Find(oldId.Value));
                        db.SaveChanges();
                    }

                }
        }


    }

    public class HomeController : MyController
    {
        public ActionResult Index()
        {
            //CheckPerson();
            return View();
        }
        public ActionResult About()
        {
            ViewBag.Message = "Puhkuste kalender"; //muutsin nime KL

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Puhkuste jäägid"; //muutsin nime KL

            return View();
        }
    }
}

Views/Departments/Create.cshtml
@model TooJaVile.Models.Department

@{
    ViewBag.Title = "Create";
}
@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")

}
<script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>

<script>
    function readURL(input) {
        if (input.files && input.files[0]) {
            var reader = new FileReader();

            reader.onload = function (e) {
                $('#datafile').attr('src', e.target.result);
            }
            reader.readAsDataURL(input.files[0]);
        }
    }
    $(document).ready(function () {
        $("#file").change(function () {
            readURL(this);
        });
    });</script>

<h2>Uue osakonna loomine</h2>


@using (Html.BeginForm("Create", "Departments", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()

<div class="form-horizontal">
    @*<h4>Osakond</h4>*@
    <hr />
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
    <div class="form-group">
        @Html.LabelFor(model => model.Name, "Nimi", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
        </div>
    </div>

    @*<div class="form-group">
            @Html.LabelFor(model => model.SortId, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.SortId, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.SortId, "", new { @class = "text-danger" })
            </div>
        </div>*@

    @*<div class="form-group">
            @Html.LabelFor(model => model.PictureId, "PictureId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("PictureId", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.PictureId, "", new { @class = "text-danger" })
            </div>
        </div>*@
    <div class="form-group">
        @Html.LabelFor(model => model.PictureId, "Lisa pilt", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.HiddenFor(x => x.PictureId) @*//kui pilt on olemas, siis on on seal ja keegi ei korja seda ära.*@
            <input type="file" name="file" id="file" />
        </div>
    </div>

   


    <div class="form-group">
        <div class="col-md-offset-2 col-md-10">
            <input type="submit" value="Kinnita" class="btn btn-default" />
        </div>
    </div>
</div>
}

<div>
    @Html.ActionLink("Tagasi nimekirja", "Index")
</div>

Views/Departments/Delete.cshtml
@model TooJaVile.Models.Department

@{
    ViewBag.Title = "Delete";
}

<h2>Osakonna kustutamine</h2>

<h3>Kas oled kindel, et soovid osakonda kustutada?</h3>
<div>
    @*<h4>Osakond</h4>*@
    <hr />
    <dl class="dl-horizontal">
        <dt>
            Nimi
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Name)
        </dd>

        @*<dt>
            @Html.DisplayNameFor(model => model.SortId)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.SortId)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.DataFile.ContentType)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.DataFile.ContentType)
        </dd>*@
        <dt>
            Pilt
            @*@Html.DisplayNameFor(model => model.DataFile.ContentType)*@
        </dt>

        <dd>
            <img src="@Url.Action("Content", "DataFiles", new {id = Model.PictureId})" height="100" />
            @*@Html.DisplayFor(model => model.PictureId)*@

        </dd>
    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Kustuta" class="btn btn-default" /> |
            @Html.ActionLink("Tagasi nimekirja", "Index")
        </div>
    }
</div>

Views/Departments/Details.cshtml
@model TooJaVile.Models.Department

@{
    ViewBag.Title = "Details";
}

<h2>Detailne vaade</h2>

<div>
    @*<h4>Osakond</h4>*@
    <hr />
    <dl class="dl-horizontal">
        <dt>
            Nimi
            @*@Html.DisplayNameFor(model => model.Name)*@
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Name)
        </dd>

        @*<dt>
            @Html.DisplayNameFor(model => model.SortId)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.SortId)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.DataFile.ContentType)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.DataFile.ContentType)
        </dd>*@
        <dt>
            Pilt
            @*@Html.DisplayNameFor(model => model.DataFile.ContentType)*@
        </dt>

        <dd>
            <img src="@Url.Action("Content", "DataFiles", new {id = Model.PictureId})" height="100" />
            @*@Html.DisplayFor(model => model.PictureId)*@

        </dd>

    </dl>
</div>

<p>
    @Html.ActionLink("Muuda", "Edit", new { id = Model.Id }) |
    @Html.ActionLink("Tagasi nimekirja", "Index")
</p>

Views/Departments/Edit.cshtml
@model TooJaVile.Models.Department

@{

    ViewBag.Title = "Edit";
}
@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")

    @Scripts.Render("~/bundles/jqueryval")
}
<script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>

<script>
    function readURL(input) {
        if (input.files && input.files[0]) {
            var reader = new FileReader();

            reader.onload = function (e) {
                $('#datafile').attr('src', e.target.result);
            }
            reader.readAsDataURL(input.files[0]);
        }
    }
    $(document).ready(function () {
        $("#file").change(function () {
            readURL(this);
        });
    });</script>


<h2>Muuda</h2>


@using (Html.BeginForm("Edit", "Departments", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()

<div class="form-horizontal">
    @*<h4>Osakond</h4>*@
    <hr />
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
    @Html.HiddenFor(model => model.Id)

    <div class="form-group">
        @Html.LabelFor(model => model.Name, "Nimi", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
        </div>
    </div>

    @*<div class="form-group">
        @Html.LabelFor(model => model.SortId, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.SortId, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.SortId, "", new { @class = "text-danger" })
        </div>
    </div>*@

    @*<div class="form-group">
            @Html.LabelFor(model => model.PictureId, "PictureId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("PictureId", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.PictureId, "", new { @class = "text-danger" })
            </div>
        </div>*@

    <div class="form-group">
        @Html.LabelFor(model => model.PictureId, "Lisa pilt", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.HiddenFor(x => x.PictureId) @*//kui pilt on olemas, siis on on seal ja keegi ei korja seda ära.*@
            <input type="file" name="file" id="file" />
            <p></p>
            <img src="@Url.Action("Content", "My", new { id=Model.PictureId })" height="120" id="datafile" />
        </div>
    </div>
    @Html.HiddenFor(x => x.PictureId)



    <div class="form-group">
        <div class="col-md-offset-2 col-md-10">
            <input type="submit" value="Salvesta" class="btn btn-default" />
        </div>
    </div>
</div>
}

<div>
    @Html.ActionLink("Tagasi nimekirja", "Index")
</div>

Views/Departments/Index.cshtml
@model IEnumerable<TooJaVile.Models.Department>

@{
    ViewBag.Title = "Index";
}

<h2>Osakonnad</h2>
<style class="table">
    table {
        border: 2px solid #de9c6c;
    }

    td, th {
        border: 1px solid #de9c6c;
    }


    tr:nth-child(even) {
        background-color: lightgray;
    }
</style>
<p>
    @Html.ActionLink("Uue osakonna loomine", "Create")
</p>
<table class="table">
    <tr>
        <th>
            @*@Html.DisplayNameFor(model => model.Name)*@
            Osakond
        </th>
        @*<th>
            @Html.DisplayNameFor(model => model.SortId)
        </th>*@
        <th>
            @*@Html.DisplayNameFor(model => model.DataFile.ContentType)*@
            Osakonna pilt
        </th>
        <th>


        </th>
    </tr>

@foreach (var item in Model) {
<tr>
    <td>
        @Html.DisplayFor(modelItem => item.Name)
    </td>
    @*<td>
            @Html.DisplayFor(modelItem => item.SortId)
        </td>*@
    <td>
        @*@Html.DisplayFor(modelItem => item.DataFile.ContentType)*@
        <img src="@Url.Action("Content", "DataFiles", new {id = item.PictureId})" height="100" />
    </td>
    @if (ViewBag.CurrentPerson.IsAccountant)
    {
        <td>
            @Html.ActionLink("Muuda", "Edit", new { id = item.Id }) |
            @Html.ActionLink("Vaata", "Details", new { id = item.Id }) |
            @Html.ActionLink("Kustuta", "Delete", new { id = item.Id })
        </td>
    }
    else
    { }
    </tr>
}

</table>